#include <stdio.h>
#include <unistd.h>
#include <Application.h>

#include "maze.h"

/*
MazeWindow class
*/

MazeWindow::MazeWindow( BRect bound, char *name, window_type type, long flags )
           :BWindow( bound, name, type, flags ){
	BRect a_rect;

	Lock();

	a_rect.Set( 0, 0, FIELD_WIDTH, FIELD_HEIGHT );
	the_view = new MazeField( this, a_rect, B_FOLLOW_ALL | B_WILL_DRAW );
	SetSizeLimits( WINDOW_MIN_WIDTH, WINDOW_MAX_WIDTH, WINDOW_MIN_HEIGHT, WINDOW_MAX_HEIGHT );
	SetPulseRate( 150000 );
	AddChild( the_view );
	the_view->InitField();
	Unlock();
	Show();

	the_view->Go();
}

bool MazeWindow::QuitRequested(){
	be_app->PostMessage( B_QUIT_REQUESTED );
	return TRUE;
}

/*
main routine
*/

int main(){
	BApplication *my_app;
	MazeWindow *a_window;
	BRect a_rect;

	my_app = new BApplication('????');

	a_rect.Set( 100, 100, 100+FIELD_WIDTH, 100+FIELD_HEIGHT );
	a_window = new MazeWindow( a_rect, "Maze", B_TITLED_WINDOW, B_WILL_ACCEPT_FIRST_CLICK );
	my_app->Run();

	delete my_app;
	return 0;
}
